"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.astMerge = exports.VisitInfo = exports.VISITOR_SKIP_CHILDREN = exports.VISITOR_REMOVE_NODE = exports.astVisitor = exports.astToSchema = exports.directoryToAst = exports.loadSchemaComposer = exports.buildSchema = void 0;
var directoryToAst_1 = require("./directoryToAst");
var astToSchema_1 = require("./astToSchema");
/**
 * Traverses directories and return GraphQLSchema instance from `graphql-js`.
 *
 * @param m – is a NodeJS Module which provides a way to load modules from scanned dir in the regular nodejs way
 * @param options – set of options which helps to customize rules of what files/dirs should be loaded or not
 */
function buildSchema(module, opts) {
    if (opts === void 0) { opts = {}; }
    return loadSchemaComposer(module, opts).buildSchema();
}
exports.buildSchema = buildSchema;
/**
 * Traverses directories and return SchemaComposer instance from `graphql-compose`.
 *
 * @param m – is a NodeJS Module which provides a way to load modules from scanned dir in the regular nodejs way
 * @param options – set of options which helps to customize rules of what files/dirs should be loaded or not
 */
function loadSchemaComposer(module, opts) {
    var ast = (0, directoryToAst_1.directoryToAst)(module, opts);
    var sc = (0, astToSchema_1.astToSchema)(ast, opts);
    return sc;
}
exports.loadSchemaComposer = loadSchemaComposer;
var directoryToAst_2 = require("./directoryToAst");
Object.defineProperty(exports, "directoryToAst", { enumerable: true, get: function () { return directoryToAst_2.directoryToAst; } });
var astToSchema_2 = require("./astToSchema");
Object.defineProperty(exports, "astToSchema", { enumerable: true, get: function () { return astToSchema_2.astToSchema; } });
__exportStar(require("./testHelpers"), exports);
__exportStar(require("./typeDefs"), exports);
var astVisitor_1 = require("./astVisitor");
Object.defineProperty(exports, "astVisitor", { enumerable: true, get: function () { return astVisitor_1.astVisitor; } });
Object.defineProperty(exports, "VISITOR_REMOVE_NODE", { enumerable: true, get: function () { return astVisitor_1.VISITOR_REMOVE_NODE; } });
Object.defineProperty(exports, "VISITOR_SKIP_CHILDREN", { enumerable: true, get: function () { return astVisitor_1.VISITOR_SKIP_CHILDREN; } });
var VisitInfo_1 = require("./VisitInfo");
Object.defineProperty(exports, "VisitInfo", { enumerable: true, get: function () { return VisitInfo_1.VisitInfo; } });
var astMerge_1 = require("./astMerge");
Object.defineProperty(exports, "astMerge", { enumerable: true, get: function () { return astMerge_1.astMerge; } });
//# sourceMappingURL=index.js.map