import { GraphQLSchema, ExecutionResult, GraphQLError } from 'graphql';
import { SchemaComposer, Resolver, ObjectTypeComposerFieldConfigAsObjectDefinition, SchemaPrinterOptions } from 'graphql-compose';
interface RunQueryOpts {
    fc: ObjectTypeComposerFieldConfigAsObjectDefinition<any, any, any> | Resolver;
    operation: string;
    variables?: Record<string, any>;
    source?: Record<string, any>;
    context?: Record<string, any>;
    schemaComposer?: SchemaComposer<any>;
}
export declare function testBuildSchema(fc: ObjectTypeComposerFieldConfigAsObjectDefinition<any, any, any> | Resolver, schemaComposer?: SchemaComposer<any>): GraphQLSchema;
export declare function testOperation(opts: RunQueryOpts): Promise<ExecutionResult>;
export declare function testOperationData(opts: Omit<RunQueryOpts, 'operation'> & {
    selectionSet: string;
}): Promise<Record<string, any> | null>;
export declare function testOperationErrors(opts: RunQueryOpts): Promise<readonly GraphQLError[] | void>;
export declare function testSDL(opts: {
    fc: ObjectTypeComposerFieldConfigAsObjectDefinition<any, any, any> | Resolver;
    schemaComposer?: SchemaComposer<any>;
    deep?: boolean;
} & SchemaPrinterOptions): string;
export {};
//# sourceMappingURL=testHelpers.d.ts.map