"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.testSDL = exports.testOperationErrors = exports.testOperationData = exports.testOperation = exports.testBuildSchema = void 0;
var graphql_1 = require("graphql");
var graphql_compose_1 = require("graphql-compose");
var FIELD = 'field';
function testBuildSchema(fc, schemaComposer) {
    var sc = schemaComposer || new graphql_compose_1.SchemaComposer();
    sc.Query.setField(FIELD, fc);
    return sc.buildSchema();
}
exports.testBuildSchema = testBuildSchema;
function _getArgsForQuery(fc, variables, schemaComposer) {
    if (variables === void 0) { variables = {}; }
    var sc = schemaComposer || new graphql_compose_1.SchemaComposer();
    sc.Query.setField(FIELD, fc);
    var varNames = Object.keys(variables);
    var argNames = sc.Query.getFieldArgNames(FIELD);
    if (argNames.length === 0 && varNames.length > 0) {
        throw new Error("FieldConfig does not have any arguments. But in test you provided the following variables: ".concat((0, graphql_compose_1.inspect)(variables)));
    }
    varNames.forEach(function (varName) {
        if (!argNames.includes(varName)) {
            throw new Error("FieldConfig does not have '".concat(varName, "' argument. Available arguments: '").concat(argNames.join("', '"), "'."));
        }
    });
    argNames.forEach(function (argName) {
        if (sc.Query.isFieldArgNonNull(FIELD, argName)) {
            var val = variables[argName];
            if (val === null || val === undefined) {
                throw new Error("FieldConfig has required argument '".concat(argName, "'. But you did not provide it in your test via variables: '").concat((0, graphql_compose_1.inspect)(variables), "'."));
            }
        }
    });
    var queryVars = varNames
        .map(function (n) { return "$".concat(n, ": ").concat(String(sc.Query.getFieldArgType(FIELD, n))); })
        .join(' ');
    var fieldVars = varNames.map(function (n) { return "".concat(n, ": $").concat(n); }).join(' ');
    return {
        queryVars: queryVars ? "(".concat(queryVars, ")") : '',
        fieldVars: fieldVars ? "(".concat(fieldVars, ")") : '',
    };
}
function testOperation(opts) {
    return __awaiter(this, void 0, void 0, function () {
        var schema, res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    schema = testBuildSchema(opts.fc, opts.schemaComposer);
                    return [4 /*yield*/, (0, graphql_1.graphql)({
                            schema: schema,
                            source: opts.operation,
                            rootValue: opts === null || opts === void 0 ? void 0 : opts.source,
                            contextValue: opts === null || opts === void 0 ? void 0 : opts.context,
                            variableValues: opts === null || opts === void 0 ? void 0 : opts.variables,
                        })];
                case 1:
                    res = _a.sent();
                    return [2 /*return*/, res];
            }
        });
    });
}
exports.testOperation = testOperation;
function testOperationData(opts) {
    var _a, _b;
    return __awaiter(this, void 0, void 0, function () {
        var selectionSet, restOpts, ac, res;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    selectionSet = opts.selectionSet, restOpts = __rest(opts, ["selectionSet"]);
                    ac = _getArgsForQuery(opts.fc, opts.variables, opts.schemaComposer);
                    return [4 /*yield*/, testOperation(__assign({ operation: "\n        query ".concat(ac.queryVars, " {\n          field").concat(ac.fieldVars, " ").concat(selectionSet.trim(), "\n        }\n      ") }, restOpts))];
                case 1:
                    res = _c.sent();
                    if (res.errors) {
                        throw new Error(((_a = res === null || res === void 0 ? void 0 : res.errors) === null || _a === void 0 ? void 0 : _a[0]) || 'GraphQL Error');
                    }
                    return [2 /*return*/, (_b = res === null || res === void 0 ? void 0 : res.data) === null || _b === void 0 ? void 0 : _b.field];
            }
        });
    });
}
exports.testOperationData = testOperationData;
function testOperationErrors(opts) {
    return __awaiter(this, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, testOperation(opts)];
                case 1:
                    res = _a.sent();
                    return [2 /*return*/, res === null || res === void 0 ? void 0 : res.errors];
            }
        });
    });
}
exports.testOperationErrors = testOperationErrors;
function testSDL(opts) {
    var _a;
    var sc = opts.schemaComposer || new graphql_compose_1.SchemaComposer();
    sc.Query.setField(FIELD, opts.fc);
    sc.buildSchema();
    return sc.Query.toSDL(__assign(__assign({}, opts), { deep: (_a = opts.deep) !== null && _a !== void 0 ? _a : true, omitDescriptions: true, omitSpecifiedByUrl: true }));
}
exports.testSDL = testSDL;
//# sourceMappingURL=testHelpers.js.map